<template>
  <!-- 
    普通查询表格
    v 1.2
    2021-04-30
    Lufthafen
  -->
  <container>
    <br />
    <a-card :bordered="false">
      <yo-table
        :columns="columns"
        :load-data="loadData"
        @query="onQuery"
        @resetQuery="onResetQuery"
        ref="table"
      >
        <Auth auth="sysApp:page" slot="query">
          <!-- 此处添加查询表单控件 -->
          <!-- ... -->
          <a-form-model-item label="应用名称">
            <a-input placeholder="请输入应用名称" v-model="query.name" />
          </a-form-model-item>
          <a-form-model-item label="唯一编码">
            <a-input placeholder="请输入唯一编码" v-model="query.code" />
          </a-form-model-item>
        </Auth>
        <Auth auth="sysApp:add" slot="operator">
          <a-button @click="onOpen('add-form')" icon="plus">新增应用</a-button>
        </Auth>
        <!-- 格式化字段内容 -->
        <!-- ... -->
        <span slot="active" slot-scope="text, record">
          {{ text ? '是' : '否' }}
          <Auth auth="sysApp:setAsDefault" v-if="!record.active">
            <yo-table-actions>
              <span></span>
              <a-popconfirm
                @confirm="onSetDefault(record)"
                placement="topRight"
                title="是否确认设置为默认应用"
              >
                <a>设为默认</a>
              </a-popconfirm>
            </yo-table-actions>
          </Auth>
        </span>
        <span slot="status" slot-scope="text">{{ bindCodeValue(text, 'commonStatus') }}</span>

        <!-- 添加操作控件 -->
        <span slot="action" slot-scope="text, record">
          <yo-table-actions>
            <Auth auth="sysApp:edit">
              <a @click="onOpen('edit-form', record)">编辑</a>
            </Auth>
            <Auth auth="sysApp:delete">
              <a-popconfirm @confirm="onDelete(record)" placement="topRight" title="是否确认删除">
                <a>删除</a>
              </a-popconfirm>
            </Auth>
            <!-- 可在此处添加其他操作控件 -->
            <!-- ... -->
          </yo-table-actions>
        </span>
      </yo-table>
    </a-card>

    <!-- 新增表单 -->
    <yo-modal-form :action="$api[api.add]" :title="'新增' + name" @ok="onReloadData" ref="add-form">
      <form-body />
    </yo-modal-form>

    <!-- 编辑表单 -->
    <yo-modal-form :action="$api[api.edit]" :title="'编辑' + name" @ok="onReloadData" ref="edit-form">
      <form-body />
    </yo-modal-form>
  </container>
</template>
<script>
import FormBody from './form';

/* 在此管理整个页面需要的接口名称 */
const api = {
  page: 'getAppPage',
  add: 'sysAppAdd',
  edit: 'sysAppEdit',
  delete: 'sysAppDelete',
  /* ... */
};

export default {
  components: {
    FormBody,
  },
  data() {
    return {
      api,

      name: '应用',

      /* 查询条件 */
      query: {},

      /* 表格字段 */
      columns: [
        {
          title: '应用名称',
          dataIndex: 'name',
          sorter: true,
        },
        {
          title: '唯一编码',
          dataIndex: 'code',
          sorter: true,
        },
        {
          title: '是否默认',
          dataIndex: 'active',
          scopedSlots: {
            customRender: 'active',
          },
          sorter: true,
        },
        {
          title: '状态',
          dataIndex: 'status',
          scopedSlots: {
            customRender: 'status',
          },
          sorter: true,
        },
        {
          title: '排序',
          dataIndex: 'sort',
          sorter: true,
        },
      ],

      /* 字典编码储存格式 */
      codes: {
        yesOrNo: [],
        commonStatus: [],
      },
    };
  },
  created() {
    /** 按需加载字典编码 */
    this.onLoadCodes();

    /** 根据权限添加操作列 */
    const flag = this.$auth({
      sysApp: [['edit'], ['delete']],
    });
    if (flag) {
      this.columns.push({
        title: '操作',
        width: '150px',
        dataIndex: 'action',
        scopedSlots: { customRender: 'action' },
      });
    }
  },
  methods: {
    /**
     * 必要的方法
     * 传给yo-table以示意数据接口及其参数和返回的数据结构
     */
    loadData(params) {
      return this.$api[api.page]({
        ...params,
        ...this.query,
      }).then((res) => {
        return res.data;
      });
    },

    /**
     * 有查询功能时的必要方法
     * 加载数据时初始化分页信息
     */
    onQuery() {
      this.$refs.table.onReloadData(true);
    },

    /**
     * 有查询功能时的必要方法
     * 重置查询条件
     */
    onResetQuery() {
      /** 在这里重置查询条件时,可对特殊的字段做保留处理 */
      this.query = {};
      this.onQuery();
    },

    /**
     * 必要方法
     * 重新列表数据
     */
    onReloadData() {
      this.$refs.table.onReloadData();
    },

    /**
     * 必要方法
     * 加载字典数据
     * 如果不需要获取相应的字典数据,此方法内容可空
     */
    onLoadCodes() {
      this.$api
        .$queue([
          this.$api.sysDictTypeDropDownAwait({ code: 'yes_or_no' }),
          this.$api.sysDictTypeDropDownAwait({ code: 'common_status' }),
          /* ... */
        ])
        .then(([code1, code2]) => {
          this.codes.yesOrNo = code1.data;
          this.codes.commonStatus = code2.data;
          /* ... */
        });
    },

    /**
     * 必要方法
     * 绑定数据字典值
     */
    bindCodeValue(code, name) {
      const c = this.codes[name].find((p) => p.code == code);
      if (c) {
        return c.value;
      }
      return null;
    },

    /**
     * 必要方法
     * 从列表页调用窗口的打开方法
     */
    onOpen(formName, record) {
      this.$refs[formName].onOpen({
        record,
        /* 按需添加其他参数 */
        /* ... */
      });
    },

    /**
     * 必要方法
     * 可以用做一系列操作的公共回调,此方法中会重新加载当前列表
     */
    onResult(success, successMessage) {
      if (success) {
        this.$message.success(successMessage);
        this.onReloadData();
      }
    },

    /**
     * 必要方法
     * 删除时调用
     */
    onDelete(record) {
      this.$refs.table.onLoading();
      this.$api[api.delete](record)
        .then(({ success }) => {
          this.onResult(success, '删除成功');
        })
        .finally(() => {
          this.$refs.table.onLoaded();
        });
    },

    onSetDefault(record) {
      this.$refs.table.onLoading();
      this.$api.sysAppSetAsDefault({ id: record.id }).then(({ success }) => {
        this.onResult(success, '设置成功');
      });
    },
  },
};
</script>